---
title: Create a new campaign
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Scorecards
---

{% callout %}
# Important note for users on the following Datadog sites: app.ddog-gov.com, us2.ddog-gov.com

{% alert level="danger" %}
This product is not supported for your selected [Datadog site](https://docs.datadoghq.com/getting_started/site.md). ({% placeholder "user-datadog-site-name" /%}).
{% /alert %}

{% /callout %}

# Create a new campaign{% #create-a-new-campaign %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                  |
| ----------------- | ------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/scorecard/campaigns |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/scorecard/campaigns |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/scorecard/campaigns      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/scorecard/campaigns      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/scorecard/campaigns  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/scorecard/campaigns     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/scorecard/campaigns |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/scorecard/campaigns |

### Overview

Creates a new scorecard campaign.

OAuth apps require the `apm_service_catalog_write, cases_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#scorecards) to access this endpoint.



### Request

#### Body Data (required)

Campaign data.

{% tab title="Model" %}

| Parent field | Field                        | Type      | Description                                                                          |
| ------------ | ---------------------------- | --------- | ------------------------------------------------------------------------------------ |
|              | data [*required*]       | object    | Data for creating a new campaign.                                                    |
| data         | attributes [*required*] | object    | Attributes for creating a new campaign.                                              |
| attributes   | description                  | string    | The description of the campaign.                                                     |
| attributes   | due_date                     | date-time | The due date of the campaign.                                                        |
| attributes   | entity_scope                 | string    | Entity scope query to filter entities for this campaign.                             |
| attributes   | guidance                     | string    | Guidance for the campaign.                                                           |
| attributes   | key [*required*]        | string    | The unique key for the campaign.                                                     |
| attributes   | name [*required*]       | string    | The name of the campaign.                                                            |
| attributes   | owner_id [*required*]   | string    | The UUID of the campaign owner.                                                      |
| attributes   | rule_ids [*required*]   | [string]  | Array of rule IDs associated with this campaign.                                     |
| attributes   | start_date [*required*] | date-time | The start date of the campaign.                                                      |
| attributes   | status                       | enum      | The status of the campaign. Allowed enum values: `in_progress,not_started,completed` |
| data         | type [*required*]       | enum      | The JSON:API type for campaigns. Allowed enum values: `campaign`                     |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "description": "Campaign to improve security posture for Q1 2024.",
      "due_date": "2024-03-31T23:59:59Z",
      "entity_scope": "kind:service AND team:platform",
      "guidance": "Please ensure all services pass the security requirements.",
      "key": "q1-security-2024",
      "name": "Q1 Security Campaign",
      "owner_id": "550e8400-e29b-41d4-a716-446655440000",
      "rule_ids": [
        "q8MQxk8TCqrHnWkx",
        "r9NRyl9UDrsIoXly"
      ],
      "start_date": "2024-01-01T00:00:00Z",
      "status": "in_progress"
    },
    "type": "campaign"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response containing campaign data.

| Parent field | Field                         | Type      | Description                                                      |
| ------------ | ----------------------------- | --------- | ---------------------------------------------------------------- |
|              | data [*required*]        | object    | Campaign data.                                                   |
| data         | attributes [*required*]  | object    | Campaign attributes.                                             |
| attributes   | created_at [*required*]  | date-time | Creation time of the campaign.                                   |
| attributes   | description                   | string    | The description of the campaign.                                 |
| attributes   | due_date                      | date-time | The due date of the campaign.                                    |
| attributes   | entity_scope                  | string    | Entity scope query to filter entities for this campaign.         |
| attributes   | guidance                      | string    | Guidance for the campaign.                                       |
| attributes   | key [*required*]         | string    | The unique key for the campaign.                                 |
| attributes   | modified_at [*required*] | date-time | Time of last campaign modification.                              |
| attributes   | name [*required*]        | string    | The name of the campaign.                                        |
| attributes   | owner [*required*]       | string    | The UUID of the campaign owner.                                  |
| attributes   | start_date [*required*]  | date-time | The start date of the campaign.                                  |
| attributes   | status [*required*]      | string    | The status of the campaign.                                      |
| data         | id [*required*]          | string    | The unique ID of the campaign.                                   |
| data         | type [*required*]        | enum      | The JSON:API type for campaigns. Allowed enum values: `campaign` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2023-12-15T10:30:00Z",
      "description": "Campaign to improve security posture for Q1 2024.",
      "due_date": "2024-03-31T23:59:59Z",
      "entity_scope": "kind:service AND team:platform",
      "guidance": "Please ensure all services pass the security requirements.",
      "key": "q1-security-2024",
      "modified_at": "2024-01-05T14:20:00Z",
      "name": "Q1 Security Campaign",
      "owner": "550e8400-e29b-41d4-a716-446655440000",
      "start_date": "2024-01-01T00:00:00Z",
      "status": "in_progress"
    },
    "id": "c10ODp0VCrrIpXmz",
    "type": "campaign"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/scorecard/campaigns" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "description": "Campaign to improve security posture for Q1 2024.",
      "due_date": "2024-03-31T23:59:59Z",
      "entity_scope": "kind:service AND team:platform",
      "guidance": "Please ensure all services pass the security requirements.",
      "key": "q1-security-2024",
      "name": "Q1 Security Campaign",
      "owner_id": "550e8400-e29b-41d4-a716-446655440000",
      "rule_ids": [
        "q8MQxk8TCqrHnWkx",
        "r9NRyl9UDrsIoXly"
      ],
      "start_date": "2024-01-01T00:00:00Z",
      "status": "in_progress"
    },
    "type": "campaign"
  }
}
EOF 
                
##### 

```python
"""
Create a new campaign returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.scorecards_api import ScorecardsApi
from datadog_api_client.v2.model.campaign_status import CampaignStatus
from datadog_api_client.v2.model.campaign_type import CampaignType
from datadog_api_client.v2.model.create_campaign_request import CreateCampaignRequest
from datadog_api_client.v2.model.create_campaign_request_attributes import CreateCampaignRequestAttributes
from datadog_api_client.v2.model.create_campaign_request_data import CreateCampaignRequestData
from datetime import datetime
from dateutil.tz import tzutc

body = CreateCampaignRequest(
    data=CreateCampaignRequestData(
        attributes=CreateCampaignRequestAttributes(
            description="Campaign to improve security posture for Q1 2024.",
            due_date=datetime(2024, 3, 31, 23, 59, 59, tzinfo=tzutc()),
            entity_scope="kind:service AND team:platform",
            guidance="Please ensure all services pass the security requirements.",
            key="q1-security-2024",
            name="Q1 Security Campaign",
            owner_id="550e8400-e29b-41d4-a716-446655440000",
            rule_ids=[
                "q8MQxk8TCqrHnWkx",
                "r9NRyl9UDrsIoXly",
            ],
            start_date=datetime(2024, 1, 1, 0, 0, tzinfo=tzutc()),
            status=CampaignStatus.IN_PROGRESS,
        ),
        type=CampaignType.CAMPAIGN,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = ScorecardsApi(api_client)
    response = api_instance.create_scorecard_campaign(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create a new campaign returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::ScorecardsAPI.new

body = DatadogAPIClient::V2::CreateCampaignRequest.new({
  data: DatadogAPIClient::V2::CreateCampaignRequestData.new({
    attributes: DatadogAPIClient::V2::CreateCampaignRequestAttributes.new({
      description: "Campaign to improve security posture for Q1 2024.",
      due_date: "2024-03-31T23:59:59Z",
      entity_scope: "kind:service AND team:platform",
      guidance: "Please ensure all services pass the security requirements.",
      key: "q1-security-2024",
      name: "Q1 Security Campaign",
      owner_id: "550e8400-e29b-41d4-a716-446655440000",
      rule_ids: [
        "q8MQxk8TCqrHnWkx",
        "r9NRyl9UDrsIoXly",
      ],
      start_date: "2024-01-01T00:00:00Z",
      status: DatadogAPIClient::V2::CampaignStatus::IN_PROGRESS,
    }),
    type: DatadogAPIClient::V2::CampaignType::CAMPAIGN,
  }),
})
p api_instance.create_scorecard_campaign(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create a new campaign returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"
	"time"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.CreateCampaignRequest{
		Data: datadogV2.CreateCampaignRequestData{
			Attributes: datadogV2.CreateCampaignRequestAttributes{
				Description: datadog.PtrString("Campaign to improve security posture for Q1 2024."),
				DueDate:     datadog.PtrTime(time.Date(2024, 3, 31, 23, 59, 59, 0, time.UTC)),
				EntityScope: datadog.PtrString("kind:service AND team:platform"),
				Guidance:    datadog.PtrString("Please ensure all services pass the security requirements."),
				Key:         "q1-security-2024",
				Name:        "Q1 Security Campaign",
				OwnerId:     "550e8400-e29b-41d4-a716-446655440000",
				RuleIds: []string{
					"q8MQxk8TCqrHnWkx",
					"r9NRyl9UDrsIoXly",
				},
				StartDate: time.Date(2024, 1, 1, 0, 0, 0, 0, time.UTC),
				Status:    datadogV2.CAMPAIGNSTATUS_IN_PROGRESS.Ptr(),
			},
			Type: datadogV2.CAMPAIGNTYPE_CAMPAIGN,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewScorecardsApi(apiClient)
	resp, r, err := api.CreateScorecardCampaign(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ScorecardsApi.CreateScorecardCampaign`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ScorecardsApi.CreateScorecardCampaign`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create a new campaign returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ScorecardsApi;
import com.datadog.api.client.v2.model.CampaignResponse;
import com.datadog.api.client.v2.model.CampaignStatus;
import com.datadog.api.client.v2.model.CampaignType;
import com.datadog.api.client.v2.model.CreateCampaignRequest;
import com.datadog.api.client.v2.model.CreateCampaignRequestAttributes;
import com.datadog.api.client.v2.model.CreateCampaignRequestData;
import java.time.OffsetDateTime;
import java.util.Arrays;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ScorecardsApi apiInstance = new ScorecardsApi(defaultClient);

    CreateCampaignRequest body =
        new CreateCampaignRequest()
            .data(
                new CreateCampaignRequestData()
                    .attributes(
                        new CreateCampaignRequestAttributes()
                            .description("Campaign to improve security posture for Q1 2024.")
                            .dueDate(OffsetDateTime.parse("2024-03-31T23:59:59Z"))
                            .entityScope("kind:service AND team:platform")
                            .guidance("Please ensure all services pass the security requirements.")
                            .key("q1-security-2024")
                            .name("Q1 Security Campaign")
                            .ownerId("550e8400-e29b-41d4-a716-446655440000")
                            .ruleIds(Arrays.asList("q8MQxk8TCqrHnWkx", "r9NRyl9UDrsIoXly"))
                            .startDate(OffsetDateTime.parse("2024-01-01T00:00:00Z"))
                            .status(CampaignStatus.IN_PROGRESS))
                    .type(CampaignType.CAMPAIGN));

    try {
      CampaignResponse result = apiInstance.createScorecardCampaign(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ScorecardsApi#createScorecardCampaign");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create a new campaign returns "Created" response
use chrono::{DateTime, Utc};
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_scorecards::ScorecardsAPI;
use datadog_api_client::datadogV2::model::CampaignStatus;
use datadog_api_client::datadogV2::model::CampaignType;
use datadog_api_client::datadogV2::model::CreateCampaignRequest;
use datadog_api_client::datadogV2::model::CreateCampaignRequestAttributes;
use datadog_api_client::datadogV2::model::CreateCampaignRequestData;

#[tokio::main]
async fn main() {
    let body = CreateCampaignRequest::new(CreateCampaignRequestData::new(
        CreateCampaignRequestAttributes::new(
            "q1-security-2024".to_string(),
            "Q1 Security Campaign".to_string(),
            "550e8400-e29b-41d4-a716-446655440000".to_string(),
            vec![
                "q8MQxk8TCqrHnWkx".to_string(),
                "r9NRyl9UDrsIoXly".to_string(),
            ],
            DateTime::parse_from_rfc3339("2024-01-01T00:00:00+00:00")
                .expect("Failed to parse datetime")
                .with_timezone(&Utc),
        )
        .description("Campaign to improve security posture for Q1 2024.".to_string())
        .due_date(
            DateTime::parse_from_rfc3339("2024-03-31T23:59:59+00:00")
                .expect("Failed to parse datetime")
                .with_timezone(&Utc),
        )
        .entity_scope("kind:service AND team:platform".to_string())
        .guidance("Please ensure all services pass the security requirements.".to_string())
        .status(CampaignStatus::IN_PROGRESS),
        CampaignType::CAMPAIGN,
    ));
    let configuration = datadog::Configuration::new();
    let api = ScorecardsAPI::with_config(configuration);
    let resp = api.create_scorecard_campaign(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create a new campaign returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.ScorecardsApi(configuration);

const params: v2.ScorecardsApiCreateScorecardCampaignRequest = {
  body: {
    data: {
      attributes: {
        description: "Campaign to improve security posture for Q1 2024.",
        dueDate: new Date(2024, 3, 31, 23, 59, 59, 0),
        entityScope: "kind:service AND team:platform",
        guidance: "Please ensure all services pass the security requirements.",
        key: "q1-security-2024",
        name: "Q1 Security Campaign",
        ownerId: "550e8400-e29b-41d4-a716-446655440000",
        ruleIds: ["q8MQxk8TCqrHnWkx", "r9NRyl9UDrsIoXly"],
        startDate: new Date(2024, 1, 1, 0, 0, 0, 0),
        status: "in_progress",
      },
      type: "campaign",
    },
  },
};

apiInstance
  .createScorecardCampaign(params)
  .then((data: v2.CampaignResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
